// *******************************************************************
//  2009 Epic Systems Corporation. Epic and Chronicles are
// registered trademarks of Epic Systems Corporation.
// 
// Author: Patrick Denney
// Description: Javascript functions to support the the iPhone reports
// 
// Revision History:
// *pwd  05/07/09 157197 - created
// *dchalla 12/9/2010 191508 - edited the replace functions.
// ********************************************************************

var AnimLen=250;
var AnimTim=15;
var currentWidth=0;
var intID="";
var isExpanded=false;
var tmID=new Array();
var moving=new Array();
var startTop=new Array();
var prevTop=new Array();

//SP inBasket related
var timerlen = 5; //was 5
var slideAniLen = 150; //was 150

var timerID = new Array();
var startTime = new Array();
var obj = new Array();
var endHeight = new Array();
var moving = new Array();
var dir = new Array();
//end of SP inBasket related

//Android scroll related
var targetElement = null;
var targetXStart = 0;
var targetYStart = 0;
var lastPageY = 0;
var scrollThreshold = window.devicePixelRatio * 10;
//end of Android scroll related

function UpdateOrientation(isPortrait) {
	
	if(isPortrait) {				
		attr="portrait";
	} else {
		attr="landscape";
	}
	
	if(!(document.body.getAttribute('orient')==attr)) {
		document.body.setAttribute('orient',attr);
		document.body.className=attr;  //this triggers all child elements to be re-evaluated
    }
	adjustEndRpt();
}

function adjustEndRpt() {
	var targetHt;
	var endDiv=base=document.getElementById("endRpt");
	var gapDiv=base=document.getElementById("endRptGap");
	gapDiv.style.height="0px";
	if(!(document.body.getAttribute('orient')=="landscape")) {
		targetHt=window.innerHeight-40;  //visible height-bottom image
	}
	else {
		targetHt=window.innerHeight-40;
	}
	
	if(endDiv.offsetTop<targetHt) {
		gapDiv.style.height=(targetHt-endDiv.offsetTop)+"px";
	}
	else {
		gapDiv.style.height="0px";
	}
}


function updateHeader(height,width) {
 	var header=document.getElementById("rptHeader");
	if(header) {
		header.style.width=width;
		header.style.height=height;
	}
}

function updateIBResultsFooter(height,width) {
 	var footer=document.getElementById("resultNavFooter");
	if(footer) {
		footer.style.width=width;
		footer.style.height=height;
	}
}

function collapseAll() {
	var didCollapse;
	
	didCollapse=adjustRows(1);
	didCollapse=(adjustSections(1) || didCollapse);
	
	return didCollapse;
}

function expandAll() {
	var didExpand;
	
	didExpand=adjustRows(0);
	didExpand=(adjustSections(0) || didExpand);
	
	return didExpand;
}

function toggleExpandCollapse() {
	var didWork=true;
	
	if(isExpanded) {
		didWork=collapseAll();
		isExpanded=false;
		
		if(!didWork){
			expandAll();
			isExpanded=true;
		}
	}
	else {
		didWork=expandAll();
		isExpanded=true;
		if(!didWork){
			collapseAll();
			isExpanded=false;
		}
	}
}

function adjustRows(collapse) {
	var rows = document.getElementsByName('colRow');
	var didAdjust=false;
	
	for(var row=0;row<rows.length;row++){
		if(collapse==1){
			if((rows[row].getAttribute('state')=="expanded") && (rows[row].getAttribute('default')=="closed")){
				expandCollapsedRows(rows[row].id);
				didAdjust=true;
			}
		}
		else{
			if(rows[row].getAttribute('state')=="collapsed"){
				expandCollapsedRows(rows[row].id);
				didAdjust=true;
			}
		}
	}
	return didAdjust;
}

function closeSections() {
	var id;
	var sections = document.getElementsByTagName('div');
	
	for(var sect=0;sect<sections.length;sect++){
		var isPrevRow=(sections[sect].className.search("prevRow")>-1)
		if((!isPrevRow) && (sections[sect].className.search("SecExpanded")>-1)) {
			//close the open section
			id=sections[sect].id;
			id=id.replace("parent","");
			expandCollapse(id);
		}
	}
	
}

function adjustSections(collapse) {
	var id;
	var didAdjust=false;
	var sections = document.getElementsByTagName('div');
	var secCompare= (collapse == true) ? "Expanded" : "Collapsed";
	var grpCompare= (collapse == true) ? "Open" : "Closed";
	
	for(var sect=0;sect<sections.length;sect++){
		var isPrevRow=(sections[sect].className.search("prevRow")>-1)
		var isSectGrp=(sections[sect].className.search("prevRow")>-1)
		if(((!isPrevRow) && (sections[sect].className.search("Sec"+secCompare)>-1)) || (sections[sect].className.search("SecGrp"+grpCompare)>-1)) {
			//close the open section/section group
			id=sections[sect].id;
			
			if(id != "") {
				expandCollapse(id,true);
				didAdjust=true;
			}
			
		}
	}
	return didAdjust;
	
}

function cancelEvent() {
	var event=window.event;
	
	if(event) {
		if(event.stopPropagation) {
			event.stopPropagation();
		} 
		else {
			event.cancelBubble=true;
		}
	}
	
}

function expandCollapsedRows(id) {
	var rowCnt;
	var dir;
	var elemId;
	var base;
	var table;
	var rows; 
	var img=document.getElementById("imgrow"+id);
	
	cancelEvent();  //cancel any parent element expand/collapse
	base=document.getElementById(id);
	table=base.parentNode;
	rows=table.childNodes;  //get all the rows in the parent table
	if(moving[id]==1){
		return;
	}
	
	moving[id]=1;
	
	if(base.getAttribute('state')=="collapsed")
	{
		dir="down";
		base.setAttribute('state',"expanded");
		img.src=img.src.replace("closed","open");
	}
	else{
		dir="up";
		base.setAttribute('state',"collapsed");
		img.src=img.src.replace("open","closed");
	}
	
	rowCnt=1
	for(var row=0; row<rows.length; row++) {  //search through all the rows
		if(rows[row].id.indexOf("row"+id)==0) {  //find the rows in the sub-section
			var elem=rows[row];
			
			elemId="row"+id+rowCnt;
			if(dir=="up") {
				elem.className=elem.className.replace("SecExpanded","SecCollapsed");
			}
			else {
				elem.className=elem.className.replace("SecCollapsed","SecExpanded");
			}
			
			rowCnt++;
		}
	}
	moving[id]=0;
	
	return;
}


function expandCollapse(id,noScroll) {
	var dir;
	var scrollTo;
	var visibleHeight;
	var elem=document.getElementById(id);
	var prevElem=document.getElementById("prev"+id);
	var hdrElem=document.getElementById("hdr"+id);
	var sectGrpHdr=document.getElementById("sectgrp"+id);
	var sectGrpSide=document.getElementById("sectgrpside"+id);
	var img=document.getElementById("img"+id);
	
	if(moving[id]=='true') {  //make sure we are not already animating the slide
		return;
	}
	moving[id]='true';
	if (elem.className.search("SecCollapsed")>-1)  {
		if(sectGrpHdr) {  //replace the section group header
			sectGrpHdr.className=sectGrpHdr.className.replace(/SectGrpClosed/g,"SectGrpOpen");
			sectGrpSide.className=sectGrpSide.className.replace(/SectGrpSideClosed/g,"SectGrpSideOpen");
		}
		elem.className=elem.className.replace("SecCollapsed","SecExpanded");  //expands out the hidden div
		if(hdrElem) {  //replace the section header
			hdrElem.className=hdrElem.className.replace("CollapseSect","noCollapseSect");	  
			visibleHeight=window.innerHeight;
			
			if((elem.offsetHeight+hdrElem.offsetHeight) >= visibleHeight) {
				//Scroll the header to the top if the content will not fit the window.
				scrollTo=hdrElem.offsetTop;  
			}
			else if((hdrElem.offsetTop+hdrElem.offsetHeight) <= window.innerHeight) {
				//Don't scroll if the content can fit without scrolling.
				scrollTo=window.pageYOffset;
			}
			else {
				//If the content can fit with some scrolling then just scroll the necessary amount.
				scrollTo=window.pageYOffset+elem.offsetHeight;
				if(scrollTo>hdrElem.offsetTop) {
					scrollTo=hdrElem.offsetTop;
				}
			}
		}
		if(prevElem) {  //remove the preview line when expanding
			prevElem.className=prevElem.className.replace("SecExpanded","SecCollapsed");
		}
		img.src=img.src.replace("closed","open");
		dir="down";
		prevTop[id]=window.pageYOffset;  //save the scroll position so we can get back there when we collapse
	}
	else  {
		if(sectGrpHdr) {  //replace the section group header
			sectGrpHdr.className=sectGrpHdr.className.replace(/SectGrpOpen/g,"SectGrpClosed");	
			sectGrpSide.className=sectGrpSide.className.replace(/SectGrpSideOpen/g,"SectGrpSideClosed");
		}
		if(hdrElem) {  //replace the section header
			hdrElem.className=hdrElem.className.replace("noCollapseSect","CollapseSect");	  
		}
		elem.className=elem.className.replace("SecExpanded","SecCollapsed");  //close up the expanded div
		if(prevElem) {  //put back the preview line
			prevElem.className=prevElem.className.replace("SecCollapsed","SecExpanded");
		}
		img.src=img.src.replace("open","closed");
		dir="up";
		scrollTo=prevTop[id];  //restore the previous scroll position
	}
	if(hdrElem && (!noScroll) && (scrollTo > -1)){ 
		startTop[id]=window.pageYOffset;
		tmID[id]=setInterval("scrollToPos('"+scrollTo+"','"+id+"','"+dir+"','"+(new Date()).getTime()+"');",AnimTim);
	}
	else if(hdrElem){
		//we don't want to scroll back if we expanded all sections at the same time
		prevTop[id]=-1;
	}
	
	setTimeout("moving['"+id+"']='false';",1000);
	
	return;
}

function scrollToPos(posTop,id,dir,stTm) {
	var scrollAmt;
	var elapsedTm=(new Date()).getTime()-stTm;
	
	if (elapsedTm > AnimLen) {
		window.scroll(0,posTop); 
		clearInterval(tmID[id]);
		delete(startTop[id]);
		delete(tmID[id]);
	}
	else {
		
		if (dir=="down")  {
			scrollAmt=(elapsedTm/AnimLen)*(posTop-startTop[id]);
			scrollAmt=Math.round(scrollAmt*100)/100;
			if (scrollAmt > 0) {
				window.scroll(0,startTop[id]+scrollAmt); 
			} 
			
		}
		else  {
			scrollAmt=(elapsedTm/AnimLen)*(startTop[id]-posTop);
			scrollAmt=Math.round(scrollAmt*100)/100;
			if (scrollAmt > 0) {
				window.scroll(0,startTop[id]-scrollAmt); 
			} 
		}
	}
	return; 	
}

function eraseInnerHTML()
{
	document.body.innerHTML="";	
}

//SP: In Basket Results related scripts
function ShowHide(aId,bId){
    var temp=aId.innerHTML;
    if (temp.length==0) {
        aId.innerHTML=bId.innerHTML;
	}
    else {
        aId.innerHTML=""; 
	}       
}

function IBOpenPatient(){
	//document.getElementById("IBButtonTest").innerHTML="Test Patient";
	window.location = "/openPatient/";       
}

function IBViewTable(){
	//document.getElementById("IBButtonTest").innerHTML="Test Patient";
	window.location = "/viewTable/";       
}

function IBPrevOrder(){
	window.location = "/leftOrderNavPressed/"; 
}

function IBMarkUnread(){
	window.location = "/markUnread/"; 
}

function toggleUnread(isEnable){
	var unreadButton=document.getElementById("markUnreadButton");
	var unreadImage=document.getElementById("markUnreadImage");	
	if(isEnable){
		unreadButton.disabled = false;
		unreadButton.style.color = 'blue';
		unreadImage.style.opacity = 1.0;		
	}else{
		unreadButton.disabled = true;
		unreadButton.style.color = 'grey';
		unreadImage.style.opacity = 0.5;		
	}	
}

function IBNextOrder(){
	window.location = "/rightOrderNavPressed/"; 
}

/*
 function updateReportBody(reportStr){
 var reportBody = document.getElementById("reportBody"); 	
 reportStr = reportStr.replace("\"","\\").replace("\'","\\'");
 reportBody.innerHTML=reportStr;	
 //reportBody.outerHTML="<div class=\"noCollapseSect\" id=\"parent\" >CBC</div>"; //reportStr;
 }
 */
function updateAbnCriticalImage(AbnCrit){
	var abnImage = document.getElementById("abnImageChange");
	var unreadButton=document.getElementById("markUnreadButton");
	//abnImage.src=url("message-status.new.png");
	if(abnImage.innerHTML.length != 0){
		if(unreadButton.disabled){ //unread or new
			if(AbnCrit == 1){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"Results_NewPanic.png\") align=\"left\" style=\"width:20px;height:20px\"> ";
				
			}else if(AbnCrit == 2){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"Results_NewAbnormal.png\") align=\"left\" style=\"width:20px;height:20px\"> ";
			}else if(AbnCrit == 3){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"ib_prev_abnormal.png\") align=\"left\" style=\"width:20px;height:20px\"> ";
			}else if(AbnCrit == 4){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"icon_high-priority_message-type-indicator.png\") align=\"left\" style=\"width:16px;height:16px\"> ";
			}else if(AbnCrit == 5){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"IB_low-priority.png\") align=\"left\" style=\"width:16px;height:16px\"> ";
			}		
		}else{
			if(AbnCrit == 1){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"Results_Panic.png\") align=\"left\" style=\"width:20px;height:20px\"> ";
				
			}else if(AbnCrit == 2){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"Results_Abnormal.png\") align=\"left\" style=\"width:20px;height:20px\"> ";
			}else if(AbnCrit == 3){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"ib_prev_abnormal_read.png\") align=\"left\" style=\"width:20px;height:20px\"> ";
			}else if(AbnCrit == 4){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"icon_high-priority_message-type-indicator.png\") align=\"left\" style=\"width:16px;height:16px\"> ";
			}else if(AbnCrit == 5){
				abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"IB_low-priority.png\") align=\"left\" style=\"width:16px;height:16px\"> ";
			}		
		}
	}
	//abnImage.innerHTML = "<IMG id=\"AbnCriticalImage\" SRC=url(\"message-status.new.png\") align=\"left\" style=\"width:20px;height:20px\"> ";
	
}

function updateOrderNavLabel(isFirst,isLast) {
	if(parseInt(isFirst)==1){		
		document.getElementById("leftOrderNavButtonFooter").style.color = 'grey';	
		document.getElementById("leftOrderNavButton").style.color = 'grey';
		document.getElementById("leftOrderNavImage").style.opacity = 0.5;				
		document.getElementById("leftOrderNavImageFooter").style.opacity = 0.5;				
	}else{			
		document.getElementById("leftOrderNavButtonFooter").style.color = 'black';
		document.getElementById("leftOrderNavButton").style.color = 'black';
		document.getElementById("leftOrderNavImageFooter").style.opacity = 1.0;				
		document.getElementById("leftOrderNavImage").style.opacity = 1.0;	
	}		
	if(parseInt(isLast)==1){		
		document.getElementById("rightOrderNavButtonFooter").style.color = 'grey';
		document.getElementById("rightOrderNavButton").style.color = 'grey';
		document.getElementById("rightOrderNavImageFooter").style.opacity = 0.5;
		document.getElementById("rightOrderNavImage").style.opacity = 0.5;			
		window.location = "/doneReviewedEnable/"; 						
	}else{		
		document.getElementById("rightOrderNavButtonFooter").style.color = 'black';
		document.getElementById("rightOrderNavButton").style.color = 'black';
		document.getElementById("rightOrderNavImageFooter").style.opacity = 1.0;
		document.getElementById("rightOrderNavImage").style.opacity = 1.0;			
	}	
}


function UpdateIBOrientation(isPortrait,patientButtonWidth,patientNameText){
	if(isPortrait){
		var centerWidth=document.getElementById("centerWidth");
		var centerWidthFooter=document.getElementById("centerWidthFooter");
		if(centerWidthFooter){
			centerWidthFooter.style.width = "47px";
		}else{
			var leftSideWidthFooter=document.getElementById("leftSideWidthFooter");
			if(leftSideWidthFooter){
				document.getElementById("rightSideWidthFooter").style.width = "90px";
				leftSideWidthFooter.style.width = "100px";				
			}			
		}
		if(centerWidth){
			document.getElementById("centerWidth").style.width = "47px";
			
		}else{
			var leftSideWidth=document.getElementById("leftSideWidth");
			if(leftSideWidth){
				document.getElementById("rightSideWidth").style.width = "90px";
				leftSideWidth.style.width = "100px";
			}			
		}
		
		var viewTable=document.getElementById("viewTableButton");
		var viewTableFooter=document.getElementById("viewTableButtonFooter");
		if(viewTable){
			viewTable.disabled = false;
			document.getElementById("viewTableButtonRightArrowImg").style.opacity = 1.0;
			document.getElementById("viewTableButtonImg").style.opacity = 1.0;
		}
		if(viewTableFooter){
			viewTableFooter.disabled = false;
			document.getElementById("viewTableButtonRightArrowImgFooter").style.opacity = 1.0;	
			document.getElementById("viewTableButtonImgFooter").style.opacity = 1.0;
		}		 
	}else{
		var centerWidth=document.getElementById("centerWidth");
		var centerWidthFooter=document.getElementById("centerWidthFooter");
		if(centerWidthFooter){
			centerWidthFooter.style.width = "204px";
		}else{
			var leftSideWidthFooter=document.getElementById("leftSideWidthFooter");
			if(leftSideWidthFooter){
				document.getElementById("rightSideWidthFooter").style.width = "170px";
				leftSideWidthFooter.style.width = "180px";				
			}			
		}
		if(centerWidth){
			centerWidth.style.width = "204px";
			
		}else{
			var leftSideWidth=document.getElementById("leftSideWidth");
			if(leftSideWidth){
				document.getElementById("rightSideWidth").style.width = "170px";
				leftSideWidth.style.width = "180px";
			}
		}
		var viewTable=document.getElementById("viewTableButton");
		var viewTableFooter=document.getElementById("viewTableButtonFooter");
		if(viewTable){
			viewTable.disabled = true;
			document.getElementById("viewTableButtonRightArrowImg").style.opacity = 0.5;
			document.getElementById("viewTableButtonImg").style.opacity = 0.5;
			
		}
		if(viewTableFooter){
			viewTableFooter.disabled = true;
			document.getElementById("viewTableButtonRightArrowImgFooter").style.opacity = 0.5;	
			document.getElementById("viewTableButtonImgFooter").style.opacity = 0.5;	
		}
	}
	
	var patientButton = document.getElementById("IBPatientButton");
	patientButton.style.width = patientButtonWidth+"px";
	patientButton.innerHTML=patientNameText+"<IMG SRC=url(\"haiku_icon_arrow-right_black.png\") ALIGN=\"absmiddle\">"; 		 
}

//SP inBasket related
///////////Sliding animations for show/hide///////////////////
function setLinkText(linkId,title){	
	linkId.innerHTML=title;	
}

function toggleSlide(bId,linkId){   
    if(document.getElementById("highlitesDetails").style.display == "none"){	
		window.location = "/highlitesOpen/"; 
		//div is hidden so let's slide down
		slidedown("highlitesDetails"); 
    }else{
		window.location = "/highlitesClose/"; 
		//div is not hidden, so slide up		
		slideup("highlitesDetails");
    }	
}

function toggleSlide2(bId,linkId){ 
    if(document.getElementById("msgDetails").style.display == "none"){	
		window.location = "/msgDetailsOpen/"; 
		//div is hidden so let's slide down
		slidedown("msgDetails");
    }else{
		window.location = "/msgDetailsClose/"; 
		//div is not hidden, so slide up		
		slideup("msgDetails");
    }	
}

function slidedown(objname){
	if(moving[objname])
		return;
	
	if(document.getElementById(objname).style.display != "none")
		return; // cannot slide down something that is already visible	
	
	moving[objname] = true;
	dir[objname] = "down";
	startslide(objname);
}

function slideup(objname){
	if(moving[objname])
		return;
	
	if(document.getElementById(objname).style.display == "none")
		return; // cannot slide up something that is already hidden
	
	moving[objname] = true;
	dir[objname] = "up";
	startslide(objname);
}

function startslide(objname){
	obj[objname] = document.getElementById(objname);	
	startTime[objname] = (new Date()).getTime();
	obj[objname].style.display = "block";
	endHeight[objname] = parseInt(obj[objname].offsetHeight);
	if(dir[objname] == "down"){
		obj[objname].style.height = "1px";
	}	
	timerID[objname] = setInterval('slidetick(\'' + objname + '\');',timerlen);
}


function slidetick(objname){
	var elapsed = (new Date()).getTime() - startTime[objname];
	
	if (elapsed > slideAniLen)
		endSlide(objname)
        else {
			var d =Math.round(elapsed / slideAniLen * endHeight[objname]);
			var f =elapsed/slideAniLen;
			if(dir[objname] == "up"){
				d = endHeight[objname] - d;
				f = 1-f;
			}
			
			obj[objname].style.height = d + "px";
			obj[objname].style.opacity = f;
			obj[objname].style.filter = 'alpha(opacity='+(f*100)+')';
			
        }
	
	return;
}

function endSlide(objname){
	clearInterval(timerID[objname]);
	
	if(dir[objname] == "up"){
		obj[objname].style.display = "none";
	    obj[objname].style.opacity = 0;
		obj[objname].style.filter = 'alpha(opacity='+(0)+')';
		
	}else{
		obj[objname].style.opacity = 1;
		obj[objname].style.filter = '';
		
	}
	
	obj[objname].style.height = endHeight[objname] + "px";
	
	delete(moving[objname]);
	delete(timerID[objname]);
	delete(startTime[objname]);
	delete(endHeight[objname]);
	delete(obj[objname]);
	delete(dir[objname]);
	
	return;
}

//end of SP inBasket related
/*
 
 function updateHeader(height,width) {
 var header=document.getElementById("rptHeader");
 if(header) {
 header.style.width=width;
 header.style.height=height;
 }
 }
 */

//Android Scroll related
function handleTouchStart(event){
	if(event.changedTouches.length == 1){
		targetElement = event.changedTouches[0].target;
		if (!targetElement) return;

		var depth = 0;

		while(((!targetElement.className) || (targetElement.className.indexOf('scrollDiv')==-1)) && (depth<10))
		{
			targetElement = targetElement.parentNode;
			depth++;
		}

		if(targetElement.className.indexOf('scrollDiv') == -1)
		{
			targetElement = null;
		}

		if(targetElement)
		{
			targetXStart = targetElement.scrollLeft + event.changedTouches[0].pageX;
			lastscreenY = event.changedTouches[0].screenY;
		}
	}
}

function handleTouchMove(event){
	if(event.changedTouches.length == 1)
	{
		if(targetElement)
		{
			var diffX = targetXStart - event.changedTouches[0].pageX;
			targetElement.scrollLeft = targetXStart - event.changedTouches[0].pageX;
			var diffY = lastscreenY - event.changedTouches[0].screenY;

			lastscreenY = event.changedTouches[0].screenY;

			if (Math.abs(diffY) < scrollThreshold)  //Okay, I don't really know why this works.
			{
				event.preventDefault();
			}
				
		}
	}
}

document.addEventListener("touchstart", handleTouchStart, true);
document.addEventListener("touchmove", handleTouchMove, true);
//End of Android Scroll related
